' Make Color Variables Global so all
' Local FN's have access to them.

DIM RECORD ColorPicker
  DIM cWhere;0
  DIM cBoxY
  DIM cBoxX
DIM END RECORD _ColorPicker:                      ' _ makes individual elements available

DIM RECORD windowForeColor
  DIM foreRBG;0
  DIM cFRed
  DIM cFGreen
  DIM cFBlue
DIM END RECORD _windowForeColor:                  ' _ makes individual elements available

DIM RECORD windowBackColor
  DIM backRBG;0
  DIM cBRed
  DIM cBGreen
  DIM cBBlue
DIM END RECORD _windoeBackColor:                  ' _ makes individual elements available

DIM cMenu:                                        ' Menu ID#

END GLOBALS


GOTO "Start":                                     ' Jump around Functions


CLEAR LOCAL
LOCAL FN ColorPicker
  
  '   Michael Lininger, Lininger Technology, 1992
  '     Last Modified:  10/17/92
  
  ' Color_Picker - This LFN displays the standard Color
  ' Wheel, which in this sample allows the user to
  ' select a new foreground and background color.
  
  ' Variable:  x% returns whether OK or Cancel button was pressed
  
  cTitle$ = "Window Background Color"
  '               Coordiante,Title,InColor,OutColor
  x% = FN GETCOLOR(cBoxVert,cTitle$,backRBG,backRBG):' IM V, pg 173
  
  cTitle$ = "Window Foreground Color"
  x% = FN GETCOLOR(cBoxVert,cTitle$,foreRBG,foreRBG):' IM V, pg 173
  
  CALL RGBBACKCOLOR(backRBG)
  CALL RGBFORECOLOR(foreRBG):                     ' Update Fore/Back with new Selections
  
END FN


CLEAR LOCAL
LOCAL FN formatWindow
  
  ' Just display some text to illustrate the change of colors
  
  TEXT 0,12,0,0
  LOCATE 1,1
  PRINT
  PRINT " Using FOREground and BACKground colors"
  PRINT " within a window via Color Picker."
  PRINT
  PRINT " Foreground Red:";TAB(20);cFRed
  PRINT " Foreground Green:";TAB(20);cFGreen
  PRINT " Foreground Blue:";TAB(20);cFBlue
  PRINT "  "
  PRINT " Background Red:";TAB(20);cBRed
  PRINT " Background Green:";TAB(20);cBGreen
  PRINT " Background Blue:";TAB(20);cBBlue
  PRINT "  "
  PRINT "Select Quit to end Program...
  
END FN 

CLEAR LOCAL
LOCAL FN ColorAlert
  DIM 60 a$(4)
  a$(1) = "Color is not available on this"
  a$(2) = "system in its present configuration.
  a$(3) = ""
  a$(4) = ""
  CALL PARAMTEXT(a$(1),a$(2),a$(3),a$(4))
  userResponse% = FN STOPALERT(1,0)
END FN


"Start"

' Check for Color Depth.  Wheel will work with B/W, but
' We will display this message in place of the wheel.

LONG IF SYSTEM(_crntDepth) < 2:                   ' B/W Setup
  FN ColorAlert
  END
END IF

cMenu = 10

cBoxVert = 0
cBoxHoriz = 0:                                    ' Center the Box (0,0)

CALL GETBACKCOLOR(backRBG):                       ' Get Current Background COLOR, put in backRBG
CALL GETFORECOLOR(foreRBG):                       ' Get Current Foreground COLOR, put in foreRBG

MENU cMenu,0,1,"Color"
MENU cMenu,1,1,"Color Picker..."
MENU cMenu,2,0,"-"
MENU cMenu,3,1,"Quit":                            ' Display Color Menu

WINDOW OFF:                                       ' Turn off Default Window
WINDOW #1,"Color Picker":                         ' Open our own window
SCROLL BUTTON 8000,50,1,100,10,,1
SCROLL BUTTON 8001,50,1,100,10,,2

done% = _False

ON DIALOG GOSUB "DialogEvent"
ON MENU GOSUB "MenuEvent"
DIALOG ON:MENU ON:BREAK ON
DO
  DIALOG OFF:MENU OFF:BREAK OFF
UNTIL done%

END

"DialogEvent"
dEvent = DIALOG(0):dItem = DIALOG(dEvent)
SELECT CASE dEvent
  CASE 1
    ' Button Event
  CASE 5:                                         ' Window update needed
    SELECT CASE dItem
      CASE 1:                                     ' Window #1, needs refreshed
        FN formatWindow
    END SELECT
END SELECT
RETURN

"MenuEvent"
mID = MENU(0):mItem = MENU(mID)
SELECT CASE mID
  CASE cMenu
    SELECT CASE mItem
      CASE 1
        FN ColorPicker
      CASE 2
      CASE 3
        done% = _True:                            ' Lets Quit the program
    END SELECT
END SELECT
MENU
RETURN

